program sirky; {toto je program souteziciho cislo 7}
uses crt,graph;
type sirka = object {jedna sirka v poli}
  x,y:integer;
  zapnuto:boolean;
  smer:boolean; {true znamena vodorovne, false svisle}
  constructor novy(ax,ay:integer;asmer:boolean);
  procedure vykresli;
  procedure zapni;
end;

pole_sirek = object
  vodsirky:array[1..10,1..11] of sirka;   {sirek je vzdy o jedna vic nez poli, jedna musi byt na konci}
  svissirky:array[1..11,1..10] of sirka;
  constructor vytvor;
  procedure oznac(ax,ay:integer;asmer:boolean);
  function zasah(x,y:integer;smer:boolean):integer;
  function zjiszap(ax,ay:integer;asmer:boolean):boolean;
end;

ovladani=object
  x,y:integer;
  smer:boolean;
  hrac:boolean; {hrac1=true,hrac2=false}
  fung:boolean; {pomocna promenna, ktera zjistuje, jestli ma program bezet dal}
  constructor vytvor(ahrac:boolean);
  procedure vykresli;
  procedure smaz;
  procedure pohzvod; {pohybovani z vodorovne polohy}
  procedure pohzsvis; {pohyb ze svisle polohy}
  procedure oznac;
  procedure rid; {procedura, ktera vola vsechny ostatni a tim ridi pohyb}
  destructor konec;
end;

var grDriver: Integer;
  grMode: Integer;
  ErrCode: Integer;
  pole:pole_sirek; {pouzivane sirky}
  ovlad:ovladani;  {zapnute ovladani}
  body1,body0:integer;  {skore jednotlivych hracu}
  hrajici:integer; {hrac, ktery je na tahu}
  pombool:boolean; {pomocna pormena na konverzi promennych typu integer na boolean
                    - souvisi s barvou hrajiciho hrace}
  hrac1,hrac2:string;

procedure skore;
var vypis:string;
begin
  setcolor(lightblue);
  str(body0,vypis);
  outtextxy(400,50,vypis);
  setcolor(white);
  outtextxy(420,50,':');
  setcolor(lightred);
  str(body1,vypis);
  outtextxy(440,50,vypis);
end;

procedure smazskore;
var vypis:string;
begin
  setcolor(black);
  str(body0,vypis);
  outtextxy(400,50,vypis);
  outtextxy(420,50,':');
  str(body1,vypis);
  outtextxy(440,50,vypis);
end;

constructor sirka.novy(ax,ay:integer;asmer:boolean);
begin
  x:=ax;
  y:=ay;
  zapnuto:=false;
  smer:=asmer;
  vykresli;
end;

procedure sirka.vykresli;
begin
  if zapnuto=false then setcolor(darkgray);
  if zapnuto=true then setcolor(green);
  if smer=true then line(20*x-20+100,20*y-20+100,20*x+100,20*y-20+100);
  if smer=false then line(20*x-20+100,20*y-20+100,20*x-20+100,20*y+100);
end;

procedure sirka.zapni;
begin
  zapnuto:=true;
  vykresli;
end;

constructor pole_sirek.vytvor;
var pomx,pomy:integer;
begin
  for pomx:=1 to 10 do
    for pomy:=1 to 11 do vodsirky[pomx,pomy].novy(pomx,pomy,true);
  for pomx:=1 to 11 do
    for pomy:=1 to 10 do svissirky[pomx,pomy].novy(pomx,pomy,false);
end;

procedure pole_sirek.oznac(ax,ay:integer;asmer:boolean);
var pomzas:integer;
begin
  if asmer=true then vodsirky[ax,ay].zapni;
  if asmer=false then svissirky[ax,ay].zapni;
  pomzas:=zasah(ax,ay,asmer);
  smazskore;
  if pomzas>0 then begin
    if hrajici=0 then body0:=body0+pomzas;
    if hrajici=1 then body1:=body1+pomzas;
    hrajici:=1-hrajici;
  end;
  hrajici:=1-hrajici;
  skore;
end;

function pole_sirek.zjiszap(ax,ay:integer;asmer:boolean):boolean;
begin
  if ((asmer=true) and (vodsirky[ax,ay].zapnuto=true)) then zjiszap:=true;
  if ((asmer=true) and (vodsirky[ax,ay].zapnuto=false)) then zjiszap:=false;
  if ((asmer=false) and (svissirky[ax,ay].zapnuto=true)) then zjiszap:=true;
  if ((asmer=false) and (svissirky[ax,ay].zapnuto=false)) then zjiszap:=false;
end;

constructor ovladani.vytvor(ahrac:boolean);
begin
  x:=1;
  y:=1;
  smer:=true;
  hrac:=ahrac;
  fung:=true;
  vykresli;
end;

procedure ovladani.vykresli;
begin
  if hrac=true then setcolor(lightred);
  if hrac=false then setcolor(lightblue);
  if smer=true then begin
    line(20*x-20+101,20*y-20+101,20*x+99,20*y-20+101);
    line(20*x-20+101,20*y-20+99,20*x+99,20*y-20+99);
  end;
  if smer=false then begin
    line(20*x-20+101,20*y-20+101,20*x-20+101,20*y+99);
    line(20*x-20+99,20*y-20+101,20*x-20+99,20*y+99);
  end;
end;

procedure ovladani.smaz;
begin
  setcolor(black);
  if smer=true then begin
    line(20*x-20+101,20*y-20+101,20*x+99,20*y-20+101);
    line(20*x-20+101,20*y-20+99,20*x+99,20*y-20+99);
  end;
  if smer=false then begin
    line(20*x-20+101,20*y-20+101,20*x-20+101,20*y+99);
    line(20*x-20+99,20*y-20+101,20*x-20+99,20*y+99);
  end;
end;

procedure ovladani.pohzvod;
var c:char;
begin
  c:=readkey;
  smaz;
  case c of
    '7':begin y:=y-1; smer:=false; end;
    '4':x:=x-1;
    '1':smer:=false;
    '9':begin x:=x+1; y:=y-1; smer:=false; end;
    '6':x:=x+1;
    '3':begin x:=x+1; smer:=false; end;
    '8':y:=y-1;
    '2':y:=y+1;
    '5':oznac;
    #27:halt;
  end;
  if ((x>10) and (smer=true)) then x:=10;
  if ((x>11) and (smer=false)) then x:=11;
  if x<1 then x:=1;
  if ((y>11) and (smer=true)) then y:=11;
  if ((y>10) and (smer=false)) then y:=10;
  if y<1 then y:=1;
  if fung=true then vykresli;
end;

procedure ovladani.pohzsvis;
var c:char;
begin
  c:=readkey;
  smaz;
  case c of
    '7':begin x:=x-1; smer:=true; end;
    '4':x:=x-1;
    '1':begin x:=x-1; y:=y+1; smer:=true; end;
    '9':smer:=true;
    '6':x:=x+1;
    '3':begin y:=y+1; smer:=true; end;
    '8':y:=y-1;
    '2':y:=y+1;
    '5':oznac;
    #27:halt;
  end;
  if ((x>10) and (smer=true)) then x:=10;
  if ((x>11) and (smer=false)) then x:=11;
  if x<1 then x:=1;
  if ((y>11) and (smer=true)) then y:=11;
  if ((y>10) and (smer=false)) then y:=10;
  if y<1 then y:=1;
  if fung=true then vykresli;
end;

procedure ovladani.rid;
var jeste:boolean;
begin
  repeat
    jeste:=true;
    if smer=true then begin
      jeste:=false;
      pohzvod;
    end;
    if ((smer=false) and (jeste=true)) then pohzsvis;
  until fung=false;
end;

destructor ovladani.konec;
begin
  smaz;
  x:=-10;
  y:=-10;
  smer:=false;
  hrac:=false;
  fung:=false;
end;


procedure ovladani.oznac;
begin
  if pole.zjiszap(x,y,smer)=false then begin
    pole.oznac(x,y,smer);
    konec;
  end;
end;

procedure trans;
begin
  if hrajici=1 then pombool:=true;
  if hrajici=0 then pombool:=false;
end;

procedure vybarvi(bx,by:integer);
begin
  if hrajici=1 then setcolor(lightred);
  if hrajici=0 then setcolor(lightblue);
  circle(20*bx+100+10-20,20*by+100+10-20,5);
end;

function pole_sirek.zasah(x,y:integer;smer:boolean):integer;
var pom:integer;
begin
  pom:=0;
  if smer=true then begin
    if ((x<11) and (y<11)) then begin
      if ((vodsirky[x,y+1].zapnuto=true) and (svissirky[x,y].zapnuto=true) and (svissirky[x+1,y].zapnuto=true)) then begin
        pom:=pom+1;
        vybarvi(x,y);
      end;
    end;
    if x<11 then begin
      if ((vodsirky[x,y-1].zapnuto=true) and (svissirky[x,y-1].zapnuto=true) and (svissirky[x+1,y-1].zapnuto=true))
      then begin
        pom:=pom+1;
        vybarvi(x,y-1);
      end;
    end;
  end;
  if smer=false then begin
    if ((x<11) and (y<11)) then begin
      if ((vodsirky[x,y].zapnuto=true) and (vodsirky[x,y+1].zapnuto=true) and (svissirky[x+1,y].zapnuto=true)) then begin
        pom:=pom+1;
        vybarvi(x,y);
      end;
    end;
    if ((x<11) and (y<11)) then begin
      if ((vodsirky[x-1,y].zapnuto=true) and (vodsirky[x-1,y+1].zapnuto=true) and (svissirky[x-1,y].zapnuto=true)) then begin
        pom:=pom+1;
        vybarvi(x-1,y);
      end;
    end;
  end;
  zasah:=pom;
end;

procedure napoveda;
begin
  setcolor(white);
  outtextxy(0,20,'Pohyb korzoru po poli probyha pomoci klaves');
  outtextxy(0,35,'na numericke klavesnici 1,2,3,4,6,7,8,9.');
  outtextxy(0,50,'Zapalka se poklada pomoci klavesy 5.');
  outtextxy(0,65,'Program lze ukoncit pomoci klavesy Esc.');
end;

begin
  hrajici:=0;
  grDriver := Detect;
  clrscr;
  write('Zadej jmeno 1. hrace ... ');
  readln(hrac1);
  write('Zadej jmeno 2. hrace ... ');
  readln(hrac2);
  writeln('Hra skonci ve chvili, kdy bude rozdeleno 100 bodu, pocateceni naskok ji');
  writeln('muze prodlouzit nebo zkratit (to je tu hlavne kuli otestovani programu).');
  write('Zadej pocatecni naskok 1. hrace ...');
  readln(body0);
  write('Zadej pocatecni naskok 2. hrace ...');
  readln(body1);
  InitGraph(grDriver, grMode,' ');
  ErrCode := GraphResult;
  if ErrCode = grOk then
  begin
    pole.vytvor;
    napoveda;
    skore;
    repeat
      trans;
      ovlad.vytvor(pombool);
      ovlad.rid;
    until (body0+body1=100);
    setcolor(white);
    if body0>body1 then outtextxy(0,350,'Vyhral '+hrac1+'.');
    if body0<body1 then outtextxy(0,350,'Vyhral '+hrac2+'.');
    if body0=body1 then outtextxy(0,350,'Remiza');
    readkey;
    CloseGraph;
  end
  else
    Writeln('Chyba grafiky: ', GraphErrorMsg(ErrCode));
end.

